function [ noise ] = complex_gaussian_noise( m, n, sigma )
%COMPLEX_GAUSSIAN_NOISE Generates m \times n matrix of complex gaussian noise
%with zero mean and standard deviation sigma (for each element).
%
% Copyright (c) 2015 Toni Volkmer
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 2 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51
% Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

noise = sigma / sqrt(2) * (randn(m,n) + 1i * randn(m,n));

end

