% Runs some of the tests of Example 5.3 from
% Potts, D., Tasche, M., Volkmer, T.
% Efficient spectral estimation by MUSIC and ESPRIT with application to sparse FFT.
% Front. Appl. Math. Stat. 2, 2016.

SNR = Inf;
bandwidth_S = 65536;
sparsity_M = 256;
type = 'box_gr1e-2';
num_signals = 100;
algorithm_name = 'esprit';
K_array = 12;
K_SVD_threshold_array = 12;
P_array = [16 32];
niter_max = 10;
epsilon_svd_list = 10.^(-3:-1:-8);

signals_filename = sprintf('signals/signals_S%d_M%d_%s_r%d.mat', bandwidth_S, sparsity_M, type, num_signals);
if exist(signals_filename,'file') == 0
  build_signals_1d( bandwidth_S, sparsity_M, type, num_signals, signals_filename );
end
test1d_run_testsets( SNR, bandwidth_S, sparsity_M, type, num_signals, algorithm_name, K_array, K_SVD_threshold_array, P_array, niter_max, epsilon_svd_list );
print_test1d( SNR, bandwidth_S, sparsity_M, type, num_signals, algorithm_name, K_array, K_SVD_threshold_array, P_array, niter_max );


% % Run (almost) all tests from Example 5.3
% SNR = Inf;
% bandwidth_S = 65536;
% sparsity_M = 256;
% type = 'box_gr1e-2';
% num_signals = 100;
% algorithm_name = 'esprit';
% K_array = [6 12 16];
% K_SVD_threshold_array = K_array;
% P_array = [16 32 64 128];
% niter_max = 10;
% epsilon_svd_list = 10.^(-3:-1:-8);
% 
% signals_filename = sprintf('signals/signals_S%d_M%d_%s_r%d.mat', bandwidth_S, sparsity_M, type, num_signals);
% if exist(signals_filename,'file') == 0
%   build_signals( bandwidth_S, sparsity_M, type, num_signals, signals_filename );
% end
% test1d_run_testsets( SNR, bandwidth_S, sparsity_M, type, num_signals, algorithm_name, K_array, K_SVD_threshold_array, P_array, niter_max, epsilon_svd_list );
% print_test1d( SNR, bandwidth_S, sparsity_M, type, num_signals, algorithm_name, K_array, K_SVD_threshold_array, P_array, niter_max );
