% Runs some of the tests of Example 5.5 from
% Potts, D., Tasche, M., Volkmer, T.
% Efficient spectral estimation by MUSIC and ESPRIT with application to sparse FFT.
% Front. Appl. Math. Stat. 2, 2016.

SNR_values = [10^10, 10^8];
bandwidth_S = 65536;
sparsity_M = 256;
type = 'unit_circle';
num_signals = 100;
algorithm_name = 'esprit';
K_array = 24;
K_SVD_threshold_array = 12;
P_array = 32;
niter_max = 10;
epsilon_svd_list = 10.^(-3:-1:-8);

signals_filename = sprintf('signals/signals_S%d_M%d_%s_r%d.mat', bandwidth_S, sparsity_M, type, num_signals);
if exist(signals_filename,'file') == 0
  build_signals_1d( bandwidth_S, sparsity_M, type, num_signals, signals_filename );
end
for SNR = SNR_values
  test1d_run_testsets( SNR, bandwidth_S, sparsity_M, type, num_signals, algorithm_name, K_array, K_SVD_threshold_array, P_array, niter_max, epsilon_svd_list );
end
for SNR = SNR_values
  print_test1d( SNR, bandwidth_S, sparsity_M, type, num_signals, algorithm_name, K_array, K_SVD_threshold_array, P_array, niter_max );
end

% % Run (almost) all tests from Example 5.5
% SNR_values = [10^10, 10^8, 10^6];
% bandwidth_S = 65536;
% sparsity_M = 256;
% type = 'unit_circle';
% num_signals = 100;
% algorithm_name = 'esprit';
% K_array = [12 12 24];
% K_SVD_threshold_array = [6 12 12];
% P_array = [32 64 128];
% niter_max = 10;
% epsilon_svd_list = 10.^(-3:-1:-8);
% 
% signals_filename = sprintf('signals/signals_S%d_M%d_%s_r%d.mat', bandwidth_S, sparsity_M, type, num_signals);
% if exist(signals_filename,'file') == 0
%   build_signals_1d( bandwidth_S, sparsity_M, type, num_signals, signals_filename );
% end
% for SNR = SNR_values
%   test1d_run_testsets( SNR, bandwidth_S, sparsity_M, type, num_signals, algorithm_name, K_array, K_SVD_threshold_array, P_array, niter_max, epsilon_svd_list );
% end
% for SNR = SNR_values
%   print_test1d( SNR, bandwidth_S, sparsity_M, type, num_signals, algorithm_name, K_array, K_SVD_threshold_array, P_array, niter_max );
% end
