function [ out ] = print_symhc_testr1l( SNR, symhc_N, d, lattice_z, lattice_S, sparsity_M, num_signals, algorithm_name, K_array, K_SVD_threshold_array, P_array, niter_max )
%PRINT_SYMHC_TESTR1L Output function of the script demo_test7_runtests.
%
% Copyright (c) 2016 Toni Volkmer
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 2 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51
% Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

out = 0;

fprintf('\n');
fprintf('algorithm = %s, # test signals = %d, sparsity = %d, max. allowed iterations = %d\n', algorithm_name, num_signals, sparsity_M, niter_max);
fprintf('symhc_N = %d, d = %d, rank-1 lattice S = %d, z = [ ', symhc_N, d, lattice_S);
for t = 1:d
  fprintf('%d ', lattice_z(t));
end
fprintf(']\n');
fprintf('---------------------------------------------------------------------------------------\n');
fprintf('           input         ||                        output\n');
fprintf('    SNR |  K | K2 |    P ||  max. |   max.  |   min.  |  # all  |     l2-   |  updated\n');
fprintf('        |    |    |      || iter. | samples |  #freq  |  freq.  |   errors  |    l2-\n');
fprintf('        |    |    |      ||       |         | correct | correct |           |  errors\n');
fprintf('---------------------------------------------------------------------------------------\n');

for iK = 1:length(K_array)
  K = K_array(iK);
  K_SVD_threshold = K_SVD_threshold_array(iK);
  for initial_P = P_array
    result_filename = sprintf('results/testr1l_symhc_results_SNR%ddB_%s_S%d_N%d_d%d_M%d_r%d_p%d_K%d_KSVD%d_niter%d.mat', round(10 * log10(SNR)), algorithm_name, lattice_S, symhc_N, d, sparsity_M, num_signals, initial_P, K, K_SVD_threshold, niter_max);
    if exist(result_filename, 'file') == 0
      continue;
    end
    load(result_filename, 'nfreq_correct_array', 'all_freq_detected_array', 'nfreq_out_array', 'nfreq_extra_array', 'max_abs_error_array', 'rel_l2_error_array', 'max_abs_error_array_full', 'rel_l2_error_array_full', 'niter_used_array', 'nsamples_array', 'p_vector', 'signals_filename', 'nruns', 'SNR', 'algorithm_name', 'N', 'd', 'lattice_z', 'lattice_S', 'M', 'initial_P', 'K', 'K_SVD_threshold', 'epsilon_svd_list', 'epsilon_spatial', 'threshold_fourier', 'epsilon_spatial', 'niter_max');
    
    %SNR_dB = 10 * log10(SNR);
    %rel_correct_runs = length(find(all_freq_detected_array==1)) / nruns;
    abs_correct_runs = length(find(all_freq_detected_array==1));

    if abs_correct_runs > 0
      %max_abserr_of_correct = max(max_abs_error_array(all_freq_detected_array==1));
      max_rell2err_of_correct = max(rel_l2_error_array(all_freq_detected_array==1));
      %max_abserr_full_of_correct = max(max_abs_error_array_full(all_freq_detected_array==1));
      max_rell2err_full_of_correct = max(rel_l2_error_array_full(all_freq_detected_array==1));
    else
      %max_abserr_of_correct = 1/0;
      max_rell2err_of_correct = 1/0;
      %max_abserr_full_of_correct = 1/0;
      max_rell2err_full_of_correct = 1/0;
    end

    if abs_correct_runs == nruns
      fprintf('%7.1e | %2d | %2d | %4d || %5d | %7d | %7d | %7d |  %.1e  |  %.1e \n', SNR, K, K_SVD_threshold, p_vector(1), max(niter_used_array), max(nsamples_array), min(nfreq_correct_array), abs_correct_runs, max_rell2err_of_correct, max_rell2err_full_of_correct);
    else
      fprintf('%7.1e | %2d | %2d | %4d || %5d | %7d | %7d | %7d | (%7.1e) | (%7.1e)\n', SNR, K, K_SVD_threshold, p_vector(1), max(niter_used_array), max(nsamples_array), min(nfreq_correct_array), abs_correct_runs, max_rell2err_of_correct, max_rell2err_full_of_correct);
    end
  end
end

end

